/*
 ******************************* Creazione file *******************************
 *-------------------------------------|--------------------------------------*
 * Creatore : Marco Savegnago					Data di creazione : 30/03/2000
 * Codice   :
 *
 * Note:
 *
 *
 ******************************* Revisione file *******************************
 *-------------------------------------|--------------------------------------*
 * Revisore :                                  Data di revisione :
 * Versione : 0
 *
 * Note:
 *
 */


#include	<vdw.h>
#include	<ntddk.h>
#include	"ntpcfomtrace.h"
#include	<memory.h>

ULONG dw_TraceWTimer;

//STATIC void mediaSumInsert(TRACEW_STR* p_trace); // Puntatore al trace.

TRACE_STR::TRACE_STR(	USHORT  w_Size,     // Dimensione del trace.
						USHORT  w_AverageSize,// Numero di misure per il calcolo della media.
						UCHAR  	by_En)      // Abilitazione.
:
	by_en(by_En),
	w_size(w_Size),
	w_averageSize(w_AverageSize)

{
	USHORT w_tmp;

// Alloco il trace.
	pw_items	=	new	USHORT[w_size];

// Esco se non c'e' memoria.
	if(pw_items==NULL)
		return;

// Inizializzo a 0 tutto il trace.
	memset(pw_items,0,w_size*sizeof(USHORT));

// Salvo il numero di elementi da inserire nel calcolo della media.
	if(w_AverageSize > w_Size)
		w_averageSize  = w_Size;
	else
		w_averageSize  = w_AverageSize;

// Salvo il puntatore al primo elemento del trace.
	pw_itemFirst =	&pw_items[0];

// Salvo il puntatore all'ultimo elemento del trace.
	pw_itemLast  = 	&pw_itemFirst[w_size-1];

// Salvo il puntatore all'ultimo elemento inserito nel trace.
	pw_itemIns   = 	pw_itemFirst;

// Reset del calcolo della medio.
	AverageReset();
}

TRACE_STR::~TRACE_STR()
{
	delete[]	pw_items;
}

USHORT TRACE_STR::WordEndianSwap(USHORT inWord)
{
	USHORT outWord;

	((UCHAR *)(&outWord))[0] = ((UCHAR *)(&inWord))[1];
	((UCHAR *)(&outWord))[1] = ((UCHAR *)(&inWord))[0];

	return outWord;
}

ULONG TRACE_STR::DoubleWordEndianSwap(ULONG inDWord)
{
	ULONG outDWord;

	((UCHAR *)(&outDWord))[0] = ((UCHAR *)(&inDWord))[3];
	((UCHAR *)(&outDWord))[1] = ((UCHAR *)(&inDWord))[2];
	((UCHAR *)(&outDWord))[2] = ((UCHAR *)(&inDWord))[1];
	((UCHAR *)(&outDWord))[3] = ((UCHAR *)(&inDWord))[0];

	return outDWord;
}

/*
 *>>>>>>>>>>>>>>>>>>>>>>>>>>> Creazione funzione <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
 --------------------------------------|--------------------------------------*
 * Creatore : Pernigotti Silvano               Data di creazione :
 * Codice   :
 *
 * Note: Funzione di swap tra la il modo big endian e little endian.
 *       Il formato little endian e' utilizzato dai microprocessori
 *       Intel 80x86 mentre il formato big-endian e' standard nelle
 *       comunicazioni via network o nei microprocessori MOTOROLA 680x0
 *       HITACHI H8xxx.
 *
 *	     La funzione fa' le seguenti operazioni alla variabile puntata:
 *
 *	     pby_data[0] = pby_data[x];
 *	     pby_data[1] = pby_data[2];
 *	     pby_data[2] = pby_data[1];
 *           .             .
 *           .             .
 *	     pby_data[x] = pby_data[0];
 *
 *>>>>>>>>>>>>>>>>>>>>>>>>>>> Revisione funzione <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
 --------------------------------------|--------------------------------------*
 * Revisore :                                  Data di revisione :
 * Versione : 0
 *
 * Note:
 *
 */
void TRACE_STR::EndianSwap(UCHAR* pby_data, // Puntatore alla variabile da swappare
				UCHAR  size   )  // Dimensione della variabile.
{
	UCHAR* pby_dataEnd;
	UCHAR  by_tmp;

	if(size <= 1)return;

	pby_dataEnd = pby_data+size-1;

	size /= 2;

	for(;size;size--)
	{

		by_tmp = *pby_data;

		*pby_data = *pby_dataEnd;

		*pby_dataEnd = by_tmp;

		pby_data++;
		pby_dataEnd--;
	}
}


void	TRACE_STR::Insert(USHORT	w_Value)
{
// Se il canale e' abilitato
	if(by_en)
	{
	// Se prima ero disabilitato
		if(!by_lastEn)
		{
		// Cancello tutti gli elementi contenuti nel trace.
			Clear();

		// Resetto il calcolo della media.
			AverageReset();

		// Memorizzo l'ora di abilitazione.
			dw_enTime = dw_TraceWTimer;
		}

    // Se il contatore degli elementi contenuti nel trace e' 
    // < della dimensione del trace.
		if(w_itemCt < w_size)
			w_itemCt++;

	// Punto al prossimo elemento da inserire nel trace.
		pw_itemIns++;

	// Se raggiungo la fine del trace ricomincio da capo.
		if(pw_itemIns > pw_itemLast)
			pw_itemIns = pw_itemFirst;

	// Inserisco il valore dell'elemento nel trace.
		*pw_itemIns = w_value;

	// Salvo il valore dell'ultimo elemento inserito.
		w_value = w_Value;

	// Inserisco l'elemento nella sommatoria per il calcolo della media.
		averageSumInsert();
	}
	// Se prima ero abilitato
	else if(by_lastEn)
	{
	// Memorizzo l'ora di disabilitazione.
		dw_disTime = dw_TraceWTimer;
	}

// Memorizzo l'ultimo stato dell'abilitazione.
	by_lastEn = by_en;

}

void TRACE_STR::averageSumInsert() // Puntatore al trace.
{
// Controllo se e' il primo elemento della sommatoria.
	if(!w_averageItemCt)
	{
	// Azzero la sommatoria degli elementi per il calcolo della media.
		dw_averageSum = 0;

	// Imposto il puntatore elemento piu' vecchio della sommatoria
	// uguale al puntatore dell'ultimo elemento inserito nel trace.
		pw_averageOldItem = pw_itemIns;
	}

// Aggiungo alla sommatoria della media l'ultimo elemento inserito nel trace
	dw_averageSum += *pw_itemIns;

// Incremento il contatore di elementi inclusi nel calcolo della media.
	w_averageItemCt++;

// Se il numero di elementi per il calcolo della media
// inserite nella sommatoria e' maggiore del numero richiesto.
	if(w_averageItemCt > w_averageSize)
	{
	// Tolgo dalla sommatoria della media l'elemento piu' vecchio.
		dw_averageSum -= *pw_averageOldItem;

	// Decremento il contatore di elementi inclusi nel calcolo della media.
		w_averageItemCt--;

	// Punto al nuovo elemento piu' vecchio
		pw_averageOldItem++;

	// Se raggiungo la fine del trace ricomincio da capo.
		if(pw_averageOldItem > pw_itemLast)
            pw_averageOldItem = pw_itemFirst;
	}
}

void	TRACE_STR::ConvertH8300Trace()
{
	USHORT 	w_H8300FirstItemAdr;
	USHORT 	w_tmp;

	USHORT* 	pw_H8300TraceBuffer=NULL;
	USHORT* 	pw_TraceBuffer=NULL;

	USHORT* 	pw_averageOldItem=NULL;// Puntatore elemento piu' vecchio della sommatoria.
	USHORT* 	pw_itemFirst=NULL;   // Puntatore al primo elemento del trace.
	USHORT* 	pw_itemLast=NULL;    // Puntatore all'ultimo elemento del trace.
	USHORT* 	pw_itemIns=NULL;     // Puntatore all'ultimo elemento inserito nel trace.


// Flag di abilitazione.
//	p_trace->by_en = p_traceH8300->by_en;

// Flag ultimo stato abilitazione,(ad uso interno).
//	p_trace->by_lastEn = p_traceH8300->by_lastEn;

// Contiene l'ora di abilitazione del trace.
// Il tempo viene espresso in  in sample count.
	dw_enTime = DoubleWordEndianSwap(dw_enTime);

// Contiene l'ora di disabilitazione del trace.
// Il tempo viene espresso in  in sample count.
	dw_disTime = DoubleWordEndianSwap(dw_disTime);

// Dimensione del trace.
	w_size = WordEndianSwap(w_size);

// Contatore elementi inseriti nel trace.
	w_itemCt = WordEndianSwap(w_itemCt);

// Valore dell'ultimo elementi inserito nel trace.
	w_value = WordEndianSwap(w_value);

// Numero elementi per il calcolo della media.
	w_averageSize = WordEndianSwap(w_averageSize);

// Sommatoria degli elementi per il calcolo della media.
	dw_averageSum = DoubleWordEndianSwap(dw_averageSum);

// Contatore elementi inseriti nella sommatoria.
	w_averageItemCt = WordEndianSwap(w_averageItemCt);

// Puntatore al primo elemento del trace.
//	pw_itemFirst = (USHORT*)(&((UCHAR*)p_trace)[sizeof(PC_TRACEW_PC_STR)]);

// Puntatore elemento piu' vecchio della sommatoria.
//	w_H8300FirstItemAdr = WordEndianSwap(pw_itemFirst);
//	w_tmp               = WordEndianSwap(pw_averageOldItem);
//	w_tmp              -= w_H8300FirstItemAdr;
//	w_tmp              /= sizeof(USHORT);

//	pw_averageOldItem = &pw_itemFirst[w_tmp];

// Puntatore all'ultimo elemento del trace.
	pw_itemLast     	= &pw_itemFirst[w_size-1];

// Puntatore all'ultimo elemento inserito nel trace.
//	w_tmp      = WordEndianSwap(pw_itemIns);
//	w_tmp     -= w_H8300FirstItemAdr;
//	w_tmp     /= sizeof(USHORT);
	w_tmp     = 0;

	pw_itemIns = &pw_itemFirst[w_tmp];

// Copio tutto il trace buffer.
	pw_TraceBuffer      = pw_itemFirst;
//	pw_H8300TraceBuffer = (USHORT*)(&((UCHAR*)p_traceH8300)[sizeof(PC_TRACEW_H8300_STR)]);

/*
	for(w_tmp = p_trace->w_size;w_tmp;w_tmp--)
	{
		*pw_TraceBuffer = H8_TO_INTEL_W(*pw_H8300TraceBuffer);
		 pw_TraceBuffer++;
		 pw_H8300TraceBuffer++;
	}
*/

// Salvo i puntatori
	pw_averageOldItem = pw_averageOldItem;
	pw_itemFirst    = pw_itemFirst;
	pw_itemLast     = pw_itemLast;
	pw_itemIns      = pw_itemIns;

}
